//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%370BACAEF90E.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%370BACAEF90E.cm

//## begin module%370BACAEF90E.cp preserve=no
//## end module%370BACAEF90E.cp

//## Module: Response%370BACAEF90E; Package specification
//## Subsystem: XSModel::Data::Detector%367691B76668
//	/local/data/verisB/dorman/Xspec/src/detector
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Data/Detector/Response.h

#ifndef RESPONSE_H
#define RESPONSE_H 1

//## begin module%370BACAEF90E.additionalIncludes preserve=no
//## end module%370BACAEF90E.additionalIncludes

//## begin module%370BACAEF90E.includes preserve=yes
// These forward declarations are required to implement the
// various "to...Response" pointer retrieval functions.  They
// exist to allow an alternative to costly dynamic_casting for
// determining Response subclass type.  The downside is that this
// base class header file must now be aware of subclass types
class RealResponse;
class MultiResponse;
class UserDummyResponse;
//## end module%370BACAEF90E.includes

// xsTypes
#include <main/xsTypes.h>
// vector
#include <vector>
// Error
#include <XSUtil/Error/Error.h>
// map
#include <map>
// XspecRegistry
#include <XSModel/DataFactory/XspecRegistry.h>

class SpectralData;
class Model;
class SumComponent;
class ResponseParam;

//## begin module%370BACAEF90E.declarations preserve=no
//## end module%370BACAEF90E.declarations

//## begin module%370BACAEF90E.additionalDeclarations preserve=yes
#include <utility>
//## end module%370BACAEF90E.additionalDeclarations


//## begin Response%362CB3EC00F4.preface preserve=yes
//## end Response%362CB3EC00F4.preface

//## Class: Response%362CB3EC00F4; Abstract
//	The Response Matrix class. Its current relationship to
//	datasets in Xspec is 1:1 but it needs to be changed to
//	cope with multiple sources as required by Integral.
//
//	The key point about this implementation is that the data
//	members of each subclass must be
//	identical: in fact, it's the read [and write] functions
//	only that are different. Thus
//	practically everything is inherited from the base class.
//## Category: XSModel::Data::Detector%36349D570394
//## Subsystem: XSModel::Data::Detector%367691B76668
//## Persistence: Transient
//## Cardinality/Multiplicity: 1..n



//## Uses: <unnamed>%37FE2193DC88;Response::InvalidBins { -> }
//## Uses: <unnamed>%3A92EECA03BC;Model { -> F}
//## Uses: <unnamed>%3AC1118E0033;SpectralData { -> F}
//## Uses: <unnamed>%3DF61F4303AF;SumComponent { -> F}
//## Uses: <unnamed>%414AFCCA0058;ResponseParam { -> F}

class Response : public RegisteredFormat  //## Inherits: <unnamed>%3ACDCDB502EF
{
  //## begin Response%362CB3EC00F4.initialDeclarations preserve=yes
  //## end Response%362CB3EC00F4.initialDeclarations

  public:
    //## Class: InvalidBins%37FE1143C090
    //## Category: XSModel::Data::Detector%36349D570394
    //## Subsystem: XSModel::Data::Detector%367691B76668
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    //## Uses: <unnamed>%37FE219C5200;Response { -> }
    //## Uses: <unnamed>%3804B65CFD34; { -> }

    class InvalidBins : public YellowAlert  //## Inherits: <unnamed>%37FE11B0EE20
    {
      public:
        //## Constructors (specified)
          //## Operation: InvalidBins%37FE3ADDB1D8; C++
          //	Class Response::InvalidBins
          //	Additional Declarations
          InvalidBins (const string& message);

      protected:
      private:
      private: //## implementation
    };

    //## Class: InvalidRequest%3CF632C001F7
    //## Category: XSModel::Data::Detector%36349D570394
    //## Subsystem: XSModel::Data::Detector%367691B76668
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class InvalidRequest : public YellowAlert  //## Inherits: <unnamed>%3CF6337001E8
    {
      public:
        //## Constructors (generated)
          InvalidRequest();

      protected:
      private:
      private: //## implementation
    };

    //## Class: GainError%414210D8019B
    //## Category: XSModel::Data::Detector%36349D570394
    //## Subsystem: XSModel::Data::Detector%367691B76668
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class GainError : public YellowAlert  //## Inherits: <unnamed>%414211010036
    {
      public:
        //## Constructors (specified)
          //## Operation: GainError%414211A60105
          GainError (const string& msg);

      protected:
      private:
      private: //## implementation
    };

    //## Class: ResponseParType%414B0000029E
    //## Category: XSModel::Data::Detector%36349D570394
    //## Subsystem: XSModel::Data::Detector%367691B76668
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef enum {OFFSET, LINEAR} ResponseParType;

    //## Destructor (generated)
      virtual ~Response();


    //## Other Operations (specified)
      //## Operation: operator*%37FDF8276E78; C++
      //	Convolution method for responses. Input model component,
      //	output folded model component.
      //	      //	For the time being implement output as Real
      //	Array.
      //	For the time being implement output as RealArray.
      //	There might be a better implementation that involved
      //	adding a folded array data member to the Component
      //	class. In the meantime the idea is to output the
      //	RealArray folded component and sum for the total
      //	model.
      //	      //	This must be modified to throw a YellowAlert
      //	Exception
      //	This must be modified to throw a YellowAlert Exception
      //	for invalid computations and to throw standard numeric
      //	exceptions.
      virtual Model& operator * (Model& model) const = 0;

      //## Operation: renumber%3A75E0E3019E
      void renumber (size_t newIndex);

      //## Operation: gSwap%3A956E44022C
      friend void gSwap (Response& left, Response& right);

      //## Operation: clone%3AAEA5670234
      virtual Response* clone () const = 0;

      //## Operation: setEnergies%3AC4BC1A02BE
      virtual void setEnergies () = 0;

      //## Operation: fileFormat%3ACDCDDC02F1
      //	fileFormat() returns true if the input filename is of
      //	the format corresponding to the class.
      virtual bool fileFormat (const string& fileName, XspecDataIO::DataType type = XspecDataIO::SpectrumType);

      //## Operation: checkRMFdata%3B9012A903C0
      //	Template method for removing RMF data from Response
      //	classes.
      //
      //	Default implementation is to call the protected virtual
      //	base class implementation which is empty
      //## Exceptions: ()
      void checkRMFdata () throw ();

      //## Operation: sensitivity%3DE51A1C00CB
      virtual RealArray sensitivity (const SpectralData* data);

      //## Operation: operator<%3B94E85700D4
      //	template method for ordering of Response objects.
      friend bool operator < (const Response& left, const Response& right);

      //## Operation: source%3B97849D0204
      virtual SpectralData* source () const = 0;

      //## Operation: source%3B9784C102BD
      virtual void source (SpectralData* spectrum) = 0;

      //## Operation: operator>%3BAF763102A5
      //	template method for ordering of Response objects.
      friend bool operator > (const Response& left, const Response& right);

      //## Operation: lowerBoundNominalEnergy%3BDDBD53030F
      const RealArray& lowerBoundNominalEnergy () const;

      //## Operation: upperBoundNominalEnergy%3BDDBDAE02EF
      const RealArray& upperBoundNominalEnergy () const;

      //## Operation: eboundsMin%3BDDBDC501EC
      virtual const RealArray& eboundsMin () const;

      //## Operation: eboundsMax%3BDDBE100216
      virtual const RealArray& eboundsMax () const;

      //## Operation: prepareForFit%3C3F13FE019A
      virtual void prepareForFit ();

      //## Operation: efficiency%3CF63266030C
      virtual const RealArray& efficiency () const;

      //## Operation: operator*%3DE7CED101D8; C++
      //	Convolution method for responses. Input model component,
      //	output folded model component.
      //
      //
      //	For the time being implement output as RealArray.
      //	There might be a better implementation that involved
      //	adding a folded array data member to the Component
      //	class. In the meantime the idea is to output the
      //	RealArray folded component and sum for the total
      //	model.
      //
      //	This must be modified to throw a YellowAlert Exception
      //	for invalid computations and to throw standard numeric
      //	exceptions.
      virtual void operator * (SumComponent& source) const = 0;

      //## Operation: energies%3ECD074B0349
      const RealArray& energies () const;

      //## Operation: applyGainFromPrompt%413DEF0302D3
      void applyGainFromPrompt (Real slope, Real intercept);

      //## Operation: removeGain%413DEF5C0109
      void removeGain ();

      //## Operation: isGainApplied%413F498E0225
      bool isGainApplied () const;

      //## Operation: makeGainParams%414AFE88008F
      bool makeGainParams (const string& slopeParamVals, const string& offsetParamVals);

      //## Operation: removeGainParams%414B01530218
      void removeGainParams ();

      //## Operation: makeParamPromptString%414EE8520071
      string makeParamPromptString () const;

      //## Operation: promptParamValues%414EE91C0186
      void promptParamValues (string& paramVals, Response::ResponseParType parType) const;

      //## Operation: setParamValues%415091DA0204
      void setParamValues (const string& paramVals, Response::ResponseParType parType);

      //## Operation: applyGainFromFit%4154924902F3
      void applyGainFromFit (Response::ResponseParType parType);

      //## Operation: makeDerivative%415B0CE80192
      virtual void makeDerivative (Real delta, RealArray& deriv, Response::ResponseParType parType);

      //## Operation: getConstGain%415B284800D0
      const ResponseParam* getConstGain () const;

      //## Operation: getLinearGain%415B287F01BC
      const ResponseParam* getLinearGain () const;

      //## Operation: calcEffAreaPerChan%42136AA10355
      virtual void calcEffAreaPerChan (RealArray& effArea);

      //## Operation: toRealResponse%43AC51C502AB
      virtual const RealResponse* toRealResponse () const;

      //## Operation: toMultiResponse%43AC538B03B0
      virtual const MultiResponse* toMultiResponse () const;

      //## Operation: toUserDummyResponse%43AC53BB0105
      virtual const UserDummyResponse* toUserDummyResponse () const;

      //## Operation: untieParamLinks%49C40DFC0296
      //	An obscure function originally created for dummyrsp.
      //	The idea is to prevent leaving any gain parameters
      //	intact if the Response is placed on a dummy hook.
      void untieParamLinks () const;

      //## Operation: registerResponseParams%49E8C69E03BD
      //	register and deregisterResponseParams only need to be
      //	called externally for cases where the Response object is
      //	unaware that it has been relocated (primarily, during a
      //	swap with a dummy response).  In all other contexts, the
      //	Response functions know when they need to insert or
      //	remove their parameters from the global ResponseParam
      //	container, and will do so without this prompting.
      void registerResponseParams () const;

      //## Operation: deregisterResponseParams%49E8C88F02BF
      //	See registerResponseParams comments.
      void deregisterResponseParams () const;

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: numEnergies%373B0D17FA29
      //	Number of Energy bins
      unsigned int numEnergies () const;
      void numEnergies (unsigned int value);

      //## Attribute: numChannels%37FE2223A3A8
      //	Number of detector channels.
      unsigned int numChannels () const;
      void numChannels (unsigned int value);

      //## Attribute: spectrumNumber%3A7725CC0067
      size_t spectrumNumber () const;
      void spectrumNumber (size_t value);

      //## Attribute: sourceNumber%3A7EEE4A0202
      size_t sourceNumber () const;
      void sourceNumber (size_t value);

      //## Attribute: dataGroup%3AC2340A0156
      size_t dataGroup () const;
      void dataGroup (size_t value);

      //## Attribute: index%3BAF7597008A
      //	Giving responses a unique id for management of
      //	multiple responses with the same name.
      size_t index () const;

      //## Attribute: active%3F85C01C0068
      bool active () const;

      //## Attribute: NO_KEYVAL%4A393ED80211
      static Real NO_KEYVAL ();

      //## Attribute: slopeKeyLimits%4A39411502F7
      //	Gain slope lower/upper hard limits read from the
      //	response file.  Leave it up to inheriting classes to
      //	store keyword names and perform the read.  If a
      //	particular bound is not found, it is set to NO_KEYVAL.
      //	These values are NOT AFFECTED by rnewpar, and therefore
      //	will not necessarily be equivalent to the actual current
      //	limits of the parameter.
      std::pair<Real,Real> slopeKeyLimits () const;

      //## Attribute: offsetKeyLimits%4A39450201C0
      //	Gain offset lower/upper hard limits as stored in the
      //	response file.  See comments for slopeKeyLimits.
      std::pair<Real,Real> offsetKeyLimits () const;

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Data::Detector::GainParameters%4142007F0135
      //## Role: Response::gainFactor%414200810338
      const std::vector<Real>& gainFactor () const;

  public:
    // Additional Public Declarations
      //## begin Response%362CB3EC00F4.public preserve=yes
      //## end Response%362CB3EC00F4.public

  protected:
    //## Constructors (generated)
      Response();

      Response(const Response &right);


    //## Other Operations (specified)
      //## Operation: RMFremove%3B9012EE024B
      virtual void RMFremove ();

      //## Operation: order%3B94E8A10032
      virtual bool order (const Response& right) const;

      //## Operation: setActive%3F85C0810128
      void setActive (bool activeStatus);

      //## Operation: shiftEffectiveArea%4140787A029A
      virtual void shiftEffectiveArea (const RealArray& newEnergies);

      //## Operation: restoreEffectiveArea%414091E502AD
      virtual void restoreEffectiveArea ();

      //## Operation: setSlopeKeyLimits%4A39476C00B5
      void setSlopeKeyLimits (const Real lower, const Real upper);

      //## Operation: setOffsetKeyLimits%4A3947EF0215
      void setOffsetKeyLimits (const Real lower, const Real upper);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: eboundsExtName%3C0BCCD1034B
      const std::string& eboundsExtName () const;
      void eboundsExtName (const std::string& value);

      //## Attribute: constGain%414AFAE0011B
      ResponseParam* constGain () const;

      //## Attribute: linearGain%414AFCE30277
      ResponseParam* linearGain () const;

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Data::Detector::<unnamed>%3BEA9C61003E
      //## Role: Response::energies%3BEA9C6102A5
      //## Qualifier: index%3BEA9C95028C; size_t
      RealArray& energies ();
      Real energies (size_t index) const;
      void energies (size_t index, Real value);

    // Additional Protected Declarations
      //## begin Response%362CB3EC00F4.protected preserve=yes
      //## end Response%362CB3EC00F4.protected

  private:
    //## Assignment Operation (generated)
      Response & operator=(const Response &right);


    //## Other Operations (specified)
      //## Operation: convolve%3C3F11A603D0
      virtual void convolve (const RealArray& flux, const RealArray& fluxErr, RealArray& foldFlux, RealArray& foldFluxErr) const;

    // Additional Private Declarations
      //## begin Response%362CB3EC00F4.private preserve=yes
      //## end Response%362CB3EC00F4.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: count%373B0D17A528
      //## begin Response::count%373B0D17A528.attr preserve=no  private: static int {V} 0
      static int s_count;
      //## end Response::count%373B0D17A528.attr

      //## begin Response::numEnergies%373B0D17FA29.attr preserve=no  public: unsigned int {V} 0
      unsigned int m_numEnergies;
      //## end Response::numEnergies%373B0D17FA29.attr

      //## begin Response::numChannels%37FE2223A3A8.attr preserve=no  public: unsigned int {U} 
      unsigned int m_numChannels;
      //## end Response::numChannels%37FE2223A3A8.attr

      //## begin Response::spectrumNumber%3A7725CC0067.attr preserve=no  public: size_t {U} specNum
      size_t m_spectrumNumber;
      //## end Response::spectrumNumber%3A7725CC0067.attr

      //## begin Response::sourceNumber%3A7EEE4A0202.attr preserve=no  public: size_t {U} 1
      size_t m_sourceNumber;
      //## end Response::sourceNumber%3A7EEE4A0202.attr

      //## begin Response::dataGroup%3AC2340A0156.attr preserve=no  public: size_t {U} 0
      size_t m_dataGroup;
      //## end Response::dataGroup%3AC2340A0156.attr

      //## begin Response::index%3BAF7597008A.attr preserve=no  public: size_t {U} 
      size_t m_index;
      //## end Response::index%3BAF7597008A.attr

      //## begin Response::eboundsExtName%3C0BCCD1034B.attr preserve=no  protected: std::string {U} 
      std::string m_eboundsExtName;
      //## end Response::eboundsExtName%3C0BCCD1034B.attr

      //## begin Response::active%3F85C01C0068.attr preserve=no  public: bool {U} 
      bool m_active;
      //## end Response::active%3F85C01C0068.attr

      //## begin Response::constGain%414AFAE0011B.attr preserve=no  protected: ResponseParam* {U} 
      ResponseParam* m_constGain;
      //## end Response::constGain%414AFAE0011B.attr

      //## begin Response::linearGain%414AFCE30277.attr preserve=no  protected: ResponseParam* {U} 
      ResponseParam* m_linearGain;
      //## end Response::linearGain%414AFCE30277.attr

      //## begin Response::NO_KEYVAL%4A393ED80211.attr preserve=no  public: static Real {UC} std::numeric_limits<Real>::min()
      static const Real s_NO_KEYVAL;
      //## end Response::NO_KEYVAL%4A393ED80211.attr

      //## begin Response::slopeKeyLimits%4A39411502F7.attr preserve=no  public: std::pair<Real,Real> {U} 
      std::pair<Real,Real> m_slopeKeyLimits;
      //## end Response::slopeKeyLimits%4A39411502F7.attr

      //## begin Response::offsetKeyLimits%4A39450201C0.attr preserve=no  public: std::pair<Real,Real> {U} 
      std::pair<Real,Real> m_offsetKeyLimits;
      //## end Response::offsetKeyLimits%4A39450201C0.attr

    // Data Members for Associations

      //## Association: XSModel::Data::Detector::<unnamed>%3BEA9C61003E
      //## begin Response::energies%3BEA9C6102A5.role preserve=no  protected: RealArray { -> 1VHgN}
      RealArray m_energies;
      //## end Response::energies%3BEA9C6102A5.role

      //## Association: XSModel::Data::Detector::GainParameters%4142007F0135
      //## begin Response::gainFactor%414200810338.role preserve=no  public: std::vector< Real > {1 -> VHgN}
      std::vector<Real> m_gainFactor;
      //## end Response::gainFactor%414200810338.role

    // Additional Implementation Declarations
      //## begin Response%362CB3EC00F4.implementation preserve=yes
      //## end Response%362CB3EC00F4.implementation

};

//## begin Response%362CB3EC00F4.postscript preserve=yes
//## end Response%362CB3EC00F4.postscript

// Class Response::InvalidBins 

// Class Response::InvalidRequest 

// Class Response::GainError 

// Class Response 


//## Other Operations (inline)
inline const RealArray& Response::energies () const
{
  //## begin Response::energies%3ECD074B0349.body preserve=yes
  return m_energies;
  //## end Response::energies%3ECD074B0349.body
}

inline const ResponseParam* Response::getConstGain () const
{
  //## begin Response::getConstGain%415B284800D0.body preserve=yes
  return m_constGain;
  //## end Response::getConstGain%415B284800D0.body
}

inline const ResponseParam* Response::getLinearGain () const
{
  //## begin Response::getLinearGain%415B287F01BC.body preserve=yes
  return m_linearGain;
  //## end Response::getLinearGain%415B287F01BC.body
}

inline const RealResponse* Response::toRealResponse () const
{
  //## begin Response::toRealResponse%43AC51C502AB.body preserve=yes
   return 0;
  //## end Response::toRealResponse%43AC51C502AB.body
}

inline const MultiResponse* Response::toMultiResponse () const
{
  //## begin Response::toMultiResponse%43AC538B03B0.body preserve=yes
   return 0;
  //## end Response::toMultiResponse%43AC538B03B0.body
}

inline const UserDummyResponse* Response::toUserDummyResponse () const
{
  //## begin Response::toUserDummyResponse%43AC53BB0105.body preserve=yes
   return 0;
  //## end Response::toUserDummyResponse%43AC53BB0105.body
}

inline void Response::setSlopeKeyLimits (const Real lower, const Real upper)
{
  //## begin Response::setSlopeKeyLimits%4A39476C00B5.body preserve=yes
   m_slopeKeyLimits.first = lower;
   m_slopeKeyLimits.second = upper;
  //## end Response::setSlopeKeyLimits%4A39476C00B5.body
}

inline void Response::setOffsetKeyLimits (const Real lower, const Real upper)
{
  //## begin Response::setOffsetKeyLimits%4A3947EF0215.body preserve=yes
   m_offsetKeyLimits.first = lower;
   m_offsetKeyLimits.second = upper;
  //## end Response::setOffsetKeyLimits%4A3947EF0215.body
}

//## Get and Set Operations for Class Attributes (inline)

inline unsigned int Response::numEnergies () const
{
  //## begin Response::numEnergies%373B0D17FA29.get preserve=no
  return m_numEnergies;
  //## end Response::numEnergies%373B0D17FA29.get
}

inline void Response::numEnergies (unsigned int value)
{
  //## begin Response::numEnergies%373B0D17FA29.set preserve=no
  m_numEnergies = value;
  //## end Response::numEnergies%373B0D17FA29.set
}

inline unsigned int Response::numChannels () const
{
  //## begin Response::numChannels%37FE2223A3A8.get preserve=no
  return m_numChannels;
  //## end Response::numChannels%37FE2223A3A8.get
}

inline void Response::numChannels (unsigned int value)
{
  //## begin Response::numChannels%37FE2223A3A8.set preserve=no
  m_numChannels = value;
  //## end Response::numChannels%37FE2223A3A8.set
}

inline size_t Response::spectrumNumber () const
{
  //## begin Response::spectrumNumber%3A7725CC0067.get preserve=no
  return m_spectrumNumber;
  //## end Response::spectrumNumber%3A7725CC0067.get
}

inline void Response::spectrumNumber (size_t value)
{
  //## begin Response::spectrumNumber%3A7725CC0067.set preserve=no
  m_spectrumNumber = value;
  //## end Response::spectrumNumber%3A7725CC0067.set
}

inline size_t Response::sourceNumber () const
{
  //## begin Response::sourceNumber%3A7EEE4A0202.get preserve=no
  return m_sourceNumber;
  //## end Response::sourceNumber%3A7EEE4A0202.get
}

inline void Response::sourceNumber (size_t value)
{
  //## begin Response::sourceNumber%3A7EEE4A0202.set preserve=no
  m_sourceNumber = value;
  //## end Response::sourceNumber%3A7EEE4A0202.set
}

inline size_t Response::dataGroup () const
{
  //## begin Response::dataGroup%3AC2340A0156.get preserve=no
  return m_dataGroup;
  //## end Response::dataGroup%3AC2340A0156.get
}

inline void Response::dataGroup (size_t value)
{
  //## begin Response::dataGroup%3AC2340A0156.set preserve=no
  m_dataGroup = value;
  //## end Response::dataGroup%3AC2340A0156.set
}

inline size_t Response::index () const
{
  //## begin Response::index%3BAF7597008A.get preserve=no
  return m_index;
  //## end Response::index%3BAF7597008A.get
}

inline const std::string& Response::eboundsExtName () const
{
  //## begin Response::eboundsExtName%3C0BCCD1034B.get preserve=no
  return m_eboundsExtName;
  //## end Response::eboundsExtName%3C0BCCD1034B.get
}

inline void Response::eboundsExtName (const std::string& value)
{
  //## begin Response::eboundsExtName%3C0BCCD1034B.set preserve=no
  m_eboundsExtName = value;
  //## end Response::eboundsExtName%3C0BCCD1034B.set
}

inline bool Response::active () const
{
  //## begin Response::active%3F85C01C0068.get preserve=no
  return m_active;
  //## end Response::active%3F85C01C0068.get
}

inline ResponseParam* Response::constGain () const
{
  //## begin Response::constGain%414AFAE0011B.get preserve=no
  return m_constGain;
  //## end Response::constGain%414AFAE0011B.get
}

inline ResponseParam* Response::linearGain () const
{
  //## begin Response::linearGain%414AFCE30277.get preserve=no
  return m_linearGain;
  //## end Response::linearGain%414AFCE30277.get
}

inline Real Response::NO_KEYVAL ()
{
  //## begin Response::NO_KEYVAL%4A393ED80211.get preserve=no
  return s_NO_KEYVAL;
  //## end Response::NO_KEYVAL%4A393ED80211.get
}

inline std::pair<Real,Real> Response::slopeKeyLimits () const
{
  //## begin Response::slopeKeyLimits%4A39411502F7.get preserve=no
  return m_slopeKeyLimits;
  //## end Response::slopeKeyLimits%4A39411502F7.get
}

inline std::pair<Real,Real> Response::offsetKeyLimits () const
{
  //## begin Response::offsetKeyLimits%4A39450201C0.get preserve=no
  return m_offsetKeyLimits;
  //## end Response::offsetKeyLimits%4A39450201C0.get
}

//## Get and Set Operations for Associations (inline)

inline RealArray& Response::energies ()
{
  //## begin Response::energies%3BEA9C6102A5.get preserve=no
  return m_energies;
  //## end Response::energies%3BEA9C6102A5.get
}

inline Real Response::energies (size_t index) const
{
  //## begin Response::energies%3BEA9C6102A5.qualget preserve=no
  return m_energies[index];
  //## end Response::energies%3BEA9C6102A5.qualget
}

inline void Response::energies (size_t index, Real value)
{
  //## begin Response::energies%3BEA9C6102A5.qualset preserve=no
  m_energies[index] = value;
  //## end Response::energies%3BEA9C6102A5.qualset
}

inline const std::vector<Real>& Response::gainFactor () const
{
  //## begin Response::gainFactor%414200810338.get preserve=no
  return m_gainFactor;
  //## end Response::gainFactor%414200810338.get
}

//## begin module%370BACAEF90E.epilog preserve=yes
inline bool operator < (const Response& left, const Response& right)
{
        return left.order(right);       
}

inline bool operator > (const Response& left, const Response& right)
{
        return !left.order(right);       
}

//## end module%370BACAEF90E.epilog


#endif
